/* Copyright (C) 2009, Chuck Shotton, http://www.shotton.com/
 * Licensed under the Creative Commons Attribution-Share Alike 3.0 license.
 * See http://creativecommons.org/licenses/by-sa/3.0/ for details.
 */
package com.concluent.rssNimbus;

import java.util.Iterator;

import org.restlet.data.*;
import org.restlet.representation.Representation;
import org.restlet.representation.StringRepresentation;
import org.restlet.resource.Get;
import org.restlet.resource.Post;
import org.restlet.resource.ServerResource;

import javax.jdo.PersistenceManager;
import javax.jdo.Extent;

/**
 * Provides a basic handler for /admin URLs. A more elaborate user interface should allow settings to be
 * administered and various security and operational preferences to be managed. Right now, all it does is provide a basic
 * database dump of existing publications and subscriptions.
 * @author Chuck Shotton
 *
 */
public class AdminHandler extends ServerResource {

	@Get
	@Post
	public Representation acceptGetRepresentation (Representation entity) {
		PersistenceManager pm = RssNimbusServlet.PMF.getPersistenceManager ();
		String res = "";
		String htmlStart="<html><head><title>rssNimbus Admin</title></head><body>";
		String htmlEnd="</body></html>";
		
		res += "<h2>Known Publication URLs</h2>\n";
		
		Extent pe = pm.getExtent(PublicationObject.class, true);
		Iterator iter = pe.iterator();
		
		while (iter.hasNext()) {
			PublicationObject pub = (PublicationObject) iter.next();
			res += "<a href=\"" + pub.getURL() + "\" target=nunu>" + pub.getURL() + "</a><br>\n";
		}
		
		res += "<h2>Active Subscriptions</h2>\n";
		pe = pm.getExtent(SubscriptionObject.class, true);
		iter = pe.iterator();
		
		while (iter.hasNext()) {
			SubscriptionObject sub = (SubscriptionObject) iter.next();
			res += "Key: " + sub.getKey() + " timestamp: " + sub.getTimestamp() + " <a href=\"" + sub.getURL() + "\" target=nunu>" + sub.getURL() + "</a><br>\n";
		}
		
		res = htmlStart + res + htmlEnd;
		StringRepresentation result = new StringRepresentation (res);
		result.setMediaType(MediaType.TEXT_HTML);
		return result;
	}

}
