/* Copyright (C) 2009, Chuck Shotton, http://www.shotton.com/
 * Licensed under the Creative Commons Attribution-Share Alike 3.0 license.
 * See http://creativecommons.org/licenses/by-sa/3.0/ for details.
 */

package com.concluent.rssNimbus;

import org.restlet.data.*;
import org.restlet.representation.Representation;
import org.restlet.resource.Get;
import org.restlet.resource.Post;
import org.restlet.resource.ServerResource;

/**
 * Handler URLs of the form /notifyTask for Google App Engine async tasks to notify subscribers of a publication update.
 * @author Chuck Shotton
 *
 */
public class NotifyTaskHandler extends ServerResource {

	@Get
	@Post
	public Representation acceptRepresentation(Representation entity) {
		Representation result = null;
		Form form = new Form (entity);
		String key = form.getFirstValue ("key");
		
		if (key != null) {
			System.out.println ("NotifyTask: received key - " + key);
			Utility.notifyOneSubscriberByKey(key);
		}
		System.out.println ("NotifyTask complete.");
		return result;
	}
}
