/* Copyright (C) 2009, Chuck Shotton, http://www.shotton.com/
 * Licensed under the Creative Commons Attribution-Share Alike 3.0 license.
 * See http://creativecommons.org/licenses/by-sa/3.0/ for details.
 */

package com.concluent.rssNimbus;

import javax.jdo.JDOHelper;
import javax.jdo.PersistenceManagerFactory;

import org.restlet.Application;
import org.restlet.Restlet;
import org.restlet.routing.Router;

public class RssNimbusServlet extends Application{

	//creates a single global persistence manager for all instances to deal with potential concurrency issues
	public static final PersistenceManagerFactory PMF = JDOHelper.getPersistenceManagerFactory("transactions-optional");
	
 /**
 * Creates a root Restlet that will receive all incoming calls.
 */
@Override
	public synchronized Restlet createRoot() {
		// Create a router Restlet that routes each call to a
		// new Resource
		Router router = new Router(getContext());
	
		router.attach("/ping", PingHandler.class);
		router.attach("/saveRSS", SaveRSSHandler.class);
		router.attach("/pleaseNotify", PleaseNotifyHandler.class);
		router.attach("/admin", AdminHandler.class);
		router.attach("/notifyTask", NotifyTaskHandler.class);
		router.attachDefault(DefaultHandler.class);
		return router;
	}
}